
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
		<style>
			body {
				background: black;
				color: rgb(80, 80, 80);
			}
			body, pre, #legend span {
				font-family: Menlo, monospace;
				font-weight: bold;
			}
			#topbar {
				background: black;
				position: fixed;
				top: 0; left: 0; right: 0;
				height: 42px;
				border-bottom: 1px solid rgb(80, 80, 80);
			}
			#content {
				margin-top: 50px;
			}
			#nav, #legend {
				float: left;
				margin-left: 10px;
			}
			#legend {
				margin-top: 12px;
			}
			#nav {
				margin-top: 10px;
			}
			#legend span {
				margin: 0 5px;
			}
			.cov0 { color: rgb(192, 0, 0) }
.cov1 { color: rgb(128, 128, 128) }
.cov2 { color: rgb(116, 140, 131) }
.cov3 { color: rgb(104, 152, 134) }
.cov4 { color: rgb(92, 164, 137) }
.cov5 { color: rgb(80, 176, 140) }
.cov6 { color: rgb(68, 188, 143) }
.cov7 { color: rgb(56, 200, 146) }
.cov8 { color: rgb(44, 212, 149) }
.cov9 { color: rgb(32, 224, 152) }
.cov10 { color: rgb(20, 236, 155) }

		</style>
	</head>
	<body>
		<div id="topbar">
			<div id="nav">
				<select id="files">
				
				<option value="file0">gitlab.com/dinesh21.kumar/apiserver/main.go (3.8%)</option>
				
				<option value="file1">gitlab.com/dinesh21.kumar/apiserver/mysql_db.go (0.0%)</option>
				
				<option value="file2">gitlab.com/dinesh21.kumar/apiserver/routes.go (0.0%)</option>
				
				</select>
			</div>
			<div id="legend">
				<span>not tracked</span>
			
				<span class="cov0">not covered</span>
				<span class="cov8">covered</span>
			
			</div>
		</div>
		<div id="content">
		
		<pre class="file" id="file0" style="display: none">package main

import (
        "bytes"
        "encoding/json"
        "fmt"
        "io/ioutil"
        "log"
        "net/http"

        "github.com/joho/godotenv"
)

type post struct {
        title  string `json:"title"`
        body   string `json:"body"`
        userID int    `json:"userID"`
}

//use .env to import go environment varaibles
// init is invoked before main()
func init() <span class="cov8" title="1">{
        // loads values from .env into the system
        if err := godotenv.Load(); err != nil </span><span class="cov0" title="0">{
                log.Print("No .env file found")
        }</span>
}

func main() <span class="cov0" title="0">{
        fmt.Println("This will create a go server to handle GET,POST,PUT,DELETE requests")
        mux := newRouter()
        error := http.ListenAndServe(":8080", mux)
        if error != nil </span><span class="cov0" title="0">{
                fmt.Println("error while listen &amp; serve listen ", error)
        }</span> else<span class="cov0" title="0"> {
                fmt.Println("Go server has started listening on localhost:8080")
        }</span>
}

func welcomeMessage(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        fmt.Println("Hey Geek, Welcome to Go Lang")
        res.Header().Set("Content-Type", "text/plain")
        res.Header().Set("Server Info", "Go server")
        res.WriteHeader(200)
        res.Write([]byte("Hey Dinesh Welcome to Go Language"))
}</span>

func getPosts(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        if req.Method == "POST" </span><span class="cov0" title="0">{
                log.Panicf("does not support POST method")
        }</span>
        <span class="cov0" title="0">res.Header().Set("Content-Type", "application/json")
        req.ParseForm()
        fmt.Println("request Form values  = ", req.Form)
        postID := req.Form.Get("post_id")
        fmt.Println("post id   = ", postID)
        url := "https://jsonplaceholder.typicode.com/posts"
        if postID != "" </span><span class="cov0" title="0">{
                url = url + "/" + string(postID)
        }</span>
        <span class="cov0" title="0">resp, error := http.Get(url)
        if error != nil </span><span class="cov0" title="0">{
                log.Fatal()
        }</span>
        <span class="cov0" title="0">fmt.Println("response from posts api is = ")
        fmt.Println(resp)
        fmt.Println("response body from posts api is = ")
        fmt.Println(resp.Body)
        fmt.Printf("Type of response body is %T = ", resp.Body)

        bodyBytes, err := ioutil.ReadAll(resp.Body)
        if err != nil </span><span class="cov0" title="0">{
                log.Fatal("error in reading body")
        }</span> else<span class="cov0" title="0"> {
                //fmt.Println("body after converting to []byte slice ", bodyBytes)
                res.Write(bodyBytes)
        }</span>
}

func createPost(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        b, err := ioutil.ReadAll(req.Body)
        if err != nil </span><span class="cov0" title="0">{
                panic(err.Error())</span>
        }
        //var p post
        //keyVal := make(map[string]string)
        //store post body in a map
        <span class="cov0" title="0">keyVal := map[string]interface{}{}
        json.Unmarshal(b, &amp;keyVal)

        title := keyVal["title"]
        body := keyVal["body"]
        userID := keyVal["userID"]
        fmt.Println("\ntitle = ", title)
        fmt.Println("body = ", body)
        fmt.Println("userID = ", userID)
        newpost := map[string]interface{}{
                "title":  title,
                "body":   body,
                "userID": userID,
        }
        bytesRepresentation, err := json.Marshal(newpost)
        resp, err := http.Post("https://jsonplaceholder.typicode.com/posts", "application/json", bytes.NewBuffer(bytesRepresentation))
        if err != nil </span><span class="cov0" title="0">{
                log.Fatalln(err)
        }</span>
        <span class="cov0" title="0">defer resp.Body.Close()
        var result map[string]interface{}
        json.NewDecoder(resp.Body).Decode(&amp;result)

        log.Println(result)
        r, _ := json.Marshal(result)
        res.Header().Set("Content-Type", "application/json")
        res.Write(r)</span>
}

func employees(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        list := getEmployees()
        fmt.Println("employee list slice in main = ", list)
        employeeListJSON, err := json.Marshal(list)
        if err != nil </span><span class="cov0" title="0">{
                panic(err)</span>
        }
        <span class="cov0" title="0">res.Header().Set("Content-Type", "application/json")
        res.WriteHeader(200)
        res.Write(employeeListJSON)</span>
}

func addEmployee(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        body := req.Body
        keymap := map[string]interface{}{}
        b, e := ioutil.ReadAll(body)
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">json.Unmarshal(b, &amp;keymap)

        fmt.Println("add employee body is = ", keymap)
        fmt.Printf("%T = ", keymap)
        output := createEmployee(keymap)
        res.Header().Set("Content-Type", "application/text")
        res.WriteHeader(201)
        res.Write([]byte(output))</span>
}

func removeEmployee(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        body := req.Body
        keymap := map[string]interface{}{}
        b, e := ioutil.ReadAll(body)
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">json.Unmarshal(b, &amp;keymap)

        fmt.Println("remove employee body is = ", keymap)
        fmt.Printf("%T = ", keymap)
        output := deleteEmployee(keymap)
        res.Header().Set("Content-Type", "application/text")
        res.WriteHeader(201)
        res.Write([]byte(output))</span>
}

func changeEmployeeLastName(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        body := req.Body
        keymap := map[string]interface{}{}
        b, e := ioutil.ReadAll(body)
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">json.Unmarshal(b, &amp;keymap)

        fmt.Println("update employee body is = ", keymap)
        fmt.Printf("%T = ", keymap)
        output := updateEmployee(keymap)
        res.Header().Set("Content-Type", "application/text")
        res.WriteHeader(201)
        res.Write([]byte(output))</span>
}

func exampleV1Handl(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        res.Header().Set("Content-Type", "application/text")
        res.WriteHeader(200)
        res.Write([]byte("this is example version v1 response"))
}</span>

func exampleV2Handl(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{
        res.Header().Set("Content-Type", "application/text")
        res.WriteHeader(200)
        res.Write([]byte("this is example version v2 response"))
}</span>

//call multiple api in parallel using go routines and channels
func asyncAirlineStatus(res http.ResponseWriter, req *http.Request) <span class="cov0" title="0">{

        var urls = []string{
                "https://www.easyjet.com/",
                "https://www.skyscanner.de/",
                "https://www.ryanair.com",
                "https://wizzair.com/",
                "https://www.swiss.com/",
        }

        //lets create a channel on which checkURL will write url status
        channel := make(chan urlStatus) // urlstatus type will be written on channel
        //create wait group
        for index, url := range urls </span><span class="cov0" title="0">{
                fmt.Println(index, url)
                go checkURL(url, channel) //use go keyword for run this function parrallel for each url
        }</span>

        //read values from channel
        <span class="cov0" title="0">result := make([]urlStatus, len(urls))

        for i := 0; i &lt; len(urls); i++ </span><span class="cov0" title="0">{
                result[i] = &lt;-channel
                if result[i].status </span><span class="cov0" title="0">{
                        fmt.Println("url ", result[i].url, " is active")
                }</span> else<span class="cov0" title="0"> {
                        fmt.Println("url ", result[i].url, " is inactive")
                }</span>

        }

        //res.Write(result)
        <span class="cov0" title="0">jsonRep, e := json.Marshal(res)
        if e != nil </span><span class="cov0" title="0">{
                fmt.Print(e)
        }</span>
        <span class="cov0" title="0">res.Write(jsonRep)</span>
}

func checkURL(u string, channel chan urlStatus) <span class="cov0" title="0">{
        _, err := http.Get(u)
        if err != nil </span><span class="cov0" title="0">{
                //fmt.Println("url ", u, " is inactive")
                channel &lt;- urlStatus{status: false, url: u}
        }</span> else<span class="cov0" title="0"> {
                //fmt.Println("url ", u, " is active")
                channel &lt;- urlStatus{status: true, url: u}
        }</span>
}

type urlStatus struct {
        status bool
        url    string
}

//used for test cases
func sum(nums ...int) int <span class="cov8" title="1">{
        total := 0
        for _, num := range nums </span><span class="cov8" title="1">{
                total += num
        }</span>
        <span class="cov8" title="1">return total</span>
}
</pre>
		
		<pre class="file" id="file1" style="display: none">package main

import (
        "database/sql"
        "fmt"
        "log"
        "os"

        _ "github.com/go-sql-driver/mysql"
)

//test comment
type Employee struct {
        ID        int    `json:"id"`
        FirstName string `json:"first_name"`
        LastName  string `json:"last_name"`
        JobTitle  string `json:"job_title"`
        Salary    int    `json:"salary"`
}

//will be used by others
func getConnection() *sql.DB <span class="cov0" title="0">{
        //username,password,database,ip,port name has to be moved to env
        username, _ := os.LookupEnv("MYSQL_USER_NAME")
        password, _ := os.LookupEnv("MYSQL_USER_PASSWORD")
        ip, _ := os.LookupEnv("MYSQL_HOST_IP")
        port, _ := os.LookupEnv("MYSQL_PORT")
        dbname, _ := os.LookupEnv("MYSQL_DB_NAME")

        connectionURL := username + password + ":@tcp" + "(" + ip + ":" + port + ")/" + dbname
        fmt.Println("Connection URL is = ", connectionURL)
        db, err := sql.Open("mysql",
                connectionURL)
        if err != nil </span><span class="cov0" title="0">{
                fmt.Println("connection error")
                log.Fatal(err)
                return nil
        }</span>
        //defer db.Close()
        <span class="cov0" title="0">return db</span>
}

//return all records
func getEmployees() []Employee <span class="cov0" title="0">{
        db := getConnection()
        defer db.Close()
        rows, err := db.Query("select id,first_name,last_name,job_title,salary from employee")
        if err != nil </span><span class="cov0" title="0">{
                fmt.Println("error while reading all employee rows", err.Error())
                log.Fatal(err)
        }</span>
        <span class="cov0" title="0">defer rows.Close()
        list := make([]Employee, 0, 20)
        for rows.Next() </span><span class="cov0" title="0">{
                emp := Employee{}
                e := rows.Scan(&amp;emp.ID, &amp;emp.FirstName, &amp;emp.LastName, &amp;emp.JobTitle, &amp;emp.Salary)
                if e != nil </span><span class="cov0" title="0">{
                        fmt.Println("error while scanning rows = ", e.Error())
                        log.Fatal(err)
                }</span>
                <span class="cov0" title="0">fmt.Println("employee = ", emp)
                list = append(list, emp)</span>
        }
        <span class="cov0" title="0">fmt.Println("employee list slice = ", list)
        return list</span>
}

//Create a new employee
func createEmployee(keymap map[string]interface{}) string <span class="cov0" title="0">{
        db := getConnection()
        id := keymap["id"]
        firstName := keymap["first_name"]
        lastName := keymap["last_name"]
        jobTitle := keymap["job_title"]
        salary := keymap["salary"]

        psmt, e := db.Prepare("INSERT INTO employee VALUES( ?, ? ,?,?,?,?)")
        defer psmt.Close()
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">res, err := psmt.Exec(id, firstName, lastName, jobTitle, salary, nil)
        if err != nil </span><span class="cov0" title="0">{
                panic(err.Error())</span>
        }
        <span class="cov0" title="0">fmt.Println("inserted sucessfully", res)
        defer db.Close()
        return "inserted sucessfully"</span>
}

//delete a  employee by id
func deleteEmployee(keymap map[string]interface{}) string <span class="cov0" title="0">{
        db := getConnection()
        id := keymap["id"]
        psmt, e := db.Prepare("delete from  employee where id = ?")
        defer psmt.Close()
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">res, err := psmt.Exec(id)
        if err != nil </span><span class="cov0" title="0">{
                panic(err.Error())</span>
        }
        <span class="cov0" title="0">fmt.Println("deleted sucessfully", res)
        defer db.Close()
        return "deleted sucessfully"</span>
}

//update a  employee by id, replace old lastname to new lastname
func updateEmployee(keymap map[string]interface{}) string <span class="cov0" title="0">{
        db := getConnection()
        id := keymap["id"]
        newLastName := keymap["new_last_name"]
        psmt, e := db.Prepare("update employee  set last_name = ?  where id = ?")
        defer psmt.Close()
        if e != nil </span><span class="cov0" title="0">{
                panic(e.Error())</span>
        }
        <span class="cov0" title="0">res, err := psmt.Exec(newLastName, id)
        if err != nil </span><span class="cov0" title="0">{
                panic(err.Error())</span>
        }
        <span class="cov0" title="0">fmt.Println("updated sucessfully", res)
        defer db.Close()
        return "updated sucessfully"</span>
}
</pre>
		
		<pre class="file" id="file2" style="display: none">package main

import (
        "github.com/gorilla/mux"
)

func newRouter() *mux.Router <span class="cov0" title="0">{
        router := mux.NewRouter()
        router.HandleFunc("/posts", getPosts).Methods("GET")
        router.HandleFunc("/posts", createPost).Methods("POST")
        router.HandleFunc("/welcome", welcomeMessage).Methods("GET")
        router.HandleFunc("/employees", employees).Methods("GET")
        router.HandleFunc("/employees", addEmployee).Methods("POST")
        router.HandleFunc("/employees", removeEmployee).Methods("DELETE")
        router.HandleFunc("/employees", changeEmployeeLastName).Methods("PUT")
        router.HandleFunc("/airlines/status", asyncAirlineStatus).Methods("GET")

        //api versioning example
        api := router.PathPrefix("/api").Subrouter()
        api.HandleFunc("/v1/example", exampleV1Handl)
        api.HandleFunc("/v2/example", exampleV2Handl)
        return router
}</span>
</pre>
		
		</div>
	</body>
	<script>
	(function() {
		var files = document.getElementById('files');
		var visible;
		files.addEventListener('change', onChange, false);
		function select(part) {
			if (visible)
				visible.style.display = 'none';
			visible = document.getElementById(part);
			if (!visible)
				return;
			files.value = part;
			visible.style.display = 'block';
			location.hash = part;
		}
		function onChange() {
			select(files.value);
			window.scrollTo(0, 0);
		}
		if (location.hash != "") {
			select(location.hash.substr(1));
		}
		if (!visible) {
			select("file0");
		}
	})();
	</script>
</html>
